/*
Ory Hydra API

Documentation for all of Ory Hydra's APIs. 

API version: v2.2.0
Contact: hi@ory.sh
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package client

import (
	"encoding/json"
)

// checks if the IsReady503Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IsReady503Response{}

// IsReady503Response struct for IsReady503Response
type IsReady503Response struct {
	// Errors contains a list of errors that caused the not ready status.
	Errors *map[string]string `json:"errors,omitempty"`
	AdditionalProperties map[string]interface{}
}

type _IsReady503Response IsReady503Response

// NewIsReady503Response instantiates a new IsReady503Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIsReady503Response() *IsReady503Response {
	this := IsReady503Response{}
	return &this
}

// NewIsReady503ResponseWithDefaults instantiates a new IsReady503Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIsReady503ResponseWithDefaults() *IsReady503Response {
	this := IsReady503Response{}
	return &this
}

// GetErrors returns the Errors field value if set, zero value otherwise.
func (o *IsReady503Response) GetErrors() map[string]string {
	if o == nil || IsNil(o.Errors) {
		var ret map[string]string
		return ret
	}
	return *o.Errors
}

// GetErrorsOk returns a tuple with the Errors field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IsReady503Response) GetErrorsOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Errors) {
		return nil, false
	}
	return o.Errors, true
}

// HasErrors returns a boolean if a field has been set.
func (o *IsReady503Response) HasErrors() bool {
	if o != nil && !IsNil(o.Errors) {
		return true
	}

	return false
}

// SetErrors gets a reference to the given map[string]string and assigns it to the Errors field.
func (o *IsReady503Response) SetErrors(v map[string]string) {
	o.Errors = &v
}

func (o IsReady503Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IsReady503Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Errors) {
		toSerialize["errors"] = o.Errors
	}

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *IsReady503Response) UnmarshalJSON(bytes []byte) (err error) {
	varIsReady503Response := _IsReady503Response{}

	err = json.Unmarshal(bytes, &varIsReady503Response)

	if err != nil {
		return err
	}

	*o = IsReady503Response(varIsReady503Response)

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(bytes, &additionalProperties); err == nil {
		delete(additionalProperties, "errors")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableIsReady503Response struct {
	value *IsReady503Response
	isSet bool
}

func (v NullableIsReady503Response) Get() *IsReady503Response {
	return v.value
}

func (v *NullableIsReady503Response) Set(val *IsReady503Response) {
	v.value = val
	v.isSet = true
}

func (v NullableIsReady503Response) IsSet() bool {
	return v.isSet
}

func (v *NullableIsReady503Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIsReady503Response(val *IsReady503Response) *NullableIsReady503Response {
	return &NullableIsReady503Response{value: val, isSet: true}
}

func (v NullableIsReady503Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIsReady503Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


